import greenfoot.*;
import java.awt.Color;
import java.util.List;
public abstract class Block extends Actor
{
    GreenfootImage baseImg, miningImg;
    MCWorld w;
    boolean beingMined = false;
    int currentMineTime = 0, mineTime;
    public static final int SIZE = 20;
    public static final int HALF_SIZE = SIZE/2;
    
    public void addedToWorld(World w) {
        this.w = (MCWorld)w;
        miningImg = new GreenfootImage(baseImg);
        miningImg.setColor(new Color(0, 0, 0, 25));
        miningImg.fill();
        setImage(baseImg);
    }
    
    public void act() {
        boolean wasBeingMined = beingMined;
        double distToPlayer = Math.hypot(MCWorld.PLAYER.getX() - getX(), MCWorld.PLAYER.getY() - getY());
        if(Greenfoot.mousePressed(null)) {
            MouseInfo m = Greenfoot.getMouseInfo();
            if(!beingMined
            && m != null
            && distToPlayer < 60
            && Math.abs(getX() - m.getX()) < HALF_SIZE
            && Math.abs(getY() - m.getY()) < HALF_SIZE) {
                beingMined = true;
                MCWorld.SOMETHING_MINING = true;
            }
        } else if(Greenfoot.mouseClicked(null)
        || distToPlayer > 60){
            if(beingMined) {
                beingMined = false;
                MCWorld.SOMETHING_MINING = false;
                currentMineTime = 0;
            }
        }
        if(beingMined) {
            currentMineTime++;
            if(currentMineTime > mineTime) {
                MCWorld.SOMETHING_MINING = false;
                w.blockMined(this);
                return;
            }
        }
        if(wasBeingMined != beingMined) setImage(beingMined ? miningImg : baseImg);
    }
    
    public boolean isIntersectingPlayer() {
        return getOneIntersectingObject(Player.class) != null;
    }
}
