import greenfoot.*;
public class Menu extends World {
    private boolean loading = true;
    private boolean exiting = false;
    private int loadSpeed = 25;
    Button[] buttons;
    Actor bg2;
    
    public Menu() {
        super(MCWorld.WIDTH, MCWorld.HEIGHT, 1, false);
        addButtons();
        setPaintOrder(ControlsBox.class, AboutBox.class, Button.class);
    }
    
    public void act() {
        if(loading || exiting) {
            boolean justFinished = true;
            
            for(int i = 0; i < buttons.length; i++) {
                if(loading) {
                    if(buttons[i].getX() < MCWorld.cX) {
                        buttons[i].setLocation(buttons[i].getX() + loadSpeed, buttons[i].getY());
                        if(buttons[i].getX() > MCWorld.cX) {
                            buttons[i].setLocation(MCWorld.cX, buttons[i].getY());
                        }
                        justFinished = false;
                        break;
                    }
                } else {
                    if(buttons[i].getX() < MCWorld.WIDTH + buttons[i].getImage().getWidth()) {
                        buttons[i].setLocation(buttons[i].getX() + loadSpeed, buttons[i].getY());
                        justFinished = false;
                        break;
                    }
                }
            }
            
            if(justFinished) {
                if(loading) {
                    loading = false;
                    bg2 = new Actor() { };
                    bg2.setImage(new GreenfootImage("MenuBackground2.png"));
                    addObject(bg2, MCWorld.cX, MCWorld.cY);
                } else {
                    Greenfoot.setWorld(new MCWorld());
                }
            }
        } else {
            
        }
    }
    
    public boolean hasLoaded() {
        return !loading && !exiting;
    }
    
    private void addButtons() {
        // yPositions must have at least
        // as many elements as buttons.
        buttons = new Button[]{
            new StartButton("Start!"),
            new AboutButton("About 2D-MC"),
            new ControlsButton("2D-MC Controls")
        };
        int[] yPositions = {
            228,
            301,
            350
        };
        
        for(int i = 0; i < buttons.length; i++) {
            addObject(buttons[i], 0, 0);
            buttons[i].setLocation(-buttons[i].getImage().getWidth(), yPositions[i]);
        }
    }
    
    public void startPressed() {
        exiting = true;
        removeObject(bg2);
    }
}
